﻿Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.WebEdition

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            Map1.MapBackground.BackgroundBrush = New GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"))
            Map1.MapUnit = GeographyUnit.DecimalDegree
            Map1.MapTools.MouseCoordinate.Enabled = True

            Dim statesLayer As New ShapeFileFeatureLayer(MapPath("~/app_data/states.shp"))
            statesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1)
            statesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            Map1.StaticOverlay.Layers.Add(statesLayer)

            Dim shapesLayer As New ShapeFileFeatureLayer(MapPath("~/app_data/lineshape.shp"))
            shapesLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway1
            shapesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            Map1.DynamicOverlay.Layers.Add("Shapes", shapesLayer)

            shapesLayer.Open()
            Map1.CurrentExtent = shapesLayer.GetBoundingBox()
            shapesLayer.Close()
        End If
    End Sub

    Public Sub SaveShapes(ByVal sender As Object, ByVal e As EventArgs)
        If Not Map1.DynamicOverlay.Layers("Shapes").IsVisible Then
            Dim shapesLayer As New ShapeFileFeatureLayer(MapPath("~/app_data/lineshape.shp"), ShapeFileReadWriteMode.ReadWrite)
            shapesLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway1
            shapesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

            shapesLayer.Open()
            shapesLayer.EditTools.BeginTransaction()
            Dim features As Collection(Of Feature) = Map1.EditOverlay.Features
            For Each feature As Feature In features
                shapesLayer.EditTools.Update(feature)
            Next
            shapesLayer.EditTools.CommitTransaction()
            shapesLayer.Close()

            Map1.EditOverlay.Features.Clear()
            Map1.EditOverlay.TrackMode = TrackMode.None
            Map1.DynamicOverlay.Layers("Shapes").IsVisible = True
            Map1.DynamicOverlay.Redraw()
        End If
    End Sub

    Public Sub EditShapes(ByVal sender As Object, ByVal e As EventArgs)
        If Map1.DynamicOverlay.Layers("Shapes").IsVisible Then
            Dim shapesLayer As ShapeFileFeatureLayer = DirectCast(Map1.DynamicOverlay.Layers("Shapes"), ShapeFileFeatureLayer)

            shapesLayer.Open()
            Dim features As Collection(Of Feature) = shapesLayer.QueryTools.GetAllFeatures(ReturningColumnsType.AllColumns)
            shapesLayer.Close()

            Map1.EditOverlay.Features.Clear()
            For Each feature As Feature In features
                Map1.EditOverlay.Features.Add(feature)
            Next

            Map1.DynamicOverlay.Layers("Shapes").IsVisible = False

            Map1.EditOverlay.TrackMode = TrackMode.Edit
            Map1.EditOverlay.EditSettings.IsReshapable = True
            Map1.EditOverlay.EditSettings.IsDraggable = False
            Map1.EditOverlay.EditSettings.IsResizable = False
            Map1.EditOverlay.EditSettings.IsRotatable = False
        End If
    End Sub

End Class